<nav class='navbar navbar-expand navbar-light bg-light'>
    <a class='navbar brand'>{{title}}</a>
    <ul class='nav nav-pills'>
        <li class="nav-item"><a class='nav-link' [routerLink]="['/login']">Login</a></li>
        <li class="nav-item"><a class='nav-link' [routerLink]="['/register']">Register</a></li>
        <li class="nav-item"><a class='nav-link' [routerLink]="['/shop']">Shop</a></li>
    </ul>
</nav>

<div class="alert alert-danger" role="alert" *ngIf="invalid">
    The given credentials already exist or is invalid.
</div>

<div class="card">
    <div class="card-header">
        Sign Up!
    </div>

    <div class="card-body">
        <form novalidate
              (ngSubmit)="onAuthorize()"
              [formGroup]="registerForm">

            <div class="form-group row mb-2">
                <label class="col-md-2 col-form-label"
                       for="userNameId">Username</label>
                <div class="col-md-8">
                    <input class="form-control"
                           id="userNameId"
                           type="text"
                           placeholder="Username (required)"
                           formControlName="username"
                           [ngClass]="{'is-invalid': (registerForm.get('username').touched ||
                                            registerForm.get('username').dirty) &&
                                            !registerForm.get('username').valid }"/>
                    <span class="invalid-feedback">
            <span *ngIf="registerForm.get('username').errors?.required">
              Please enter your username.
            </span>
            <span *ngIf="registerForm.get('username').errors?.minlength">
              The username must be longer than 5 characters.
            </span>
          </span>
                </div>
            </div>

            <div class="form-group row mb-2">
                <label class="col-md-2 col-form-label"
                       for="email">Email</label>
                <div class="col-md-8">
                    <input class="form-control"
                           id="email"
                           type="email"
                           placeholder="Email (required)"
                           formControlName="email"
                           [ngClass]="{'is-invalid': (registerForm.get('email').touched ||
                                            registerForm.get('email').dirty) &&
                                            !registerForm.get('email').valid }"/>
                    <span class="invalid-feedback">
            <span *ngIf="registerForm.get('email').errors?.required">
              Please enter your email.
            </span>
          </span>
                </div>
            </div>

            <div class="form-group row mb-2">
                <label class="col-md-2 col-form-label"
                       for="firstNameId">First Name</label>
                <div class="col-md-8">
                    <input class="form-control"
                           id="firstNameId"
                           type="text"
                           placeholder="First Name (required)"
                           formControlName="firstName"
                           [ngClass]="{'is-invalid': (registerForm.get('firstName').touched ||
                                            registerForm.get('firstName').dirty) &&
                                            !registerForm.get('firstName').valid }"/>
                    <span class="invalid-feedback">
            <span *ngIf="registerForm.get('firstName').errors?.required">
              Please enter your first name.
            </span>
            <span *ngIf="registerForm.get('firstName').errors?.minlength">
              The first name must be longer than 3 characters.
            </span>
          </span>
                </div>
            </div>

            <div class="form-group row mb-2">
                <label class="col-md-2 col-form-label"
                       for="lastNameId">Last Name</label>
                <div class="col-md-8">
                    <input class="form-control"
                           id="lastNameId"
                           type="text"
                           placeholder="Last Name (required)"
                           formControlName="lastName"
                           [ngClass]="{'is-invalid': (registerForm.get('lastName').touched ||
                                            registerForm.get('lastName').dirty) &&
                                            !registerForm.get('lastName').valid }"/>
                    <span class="invalid-feedback">
            <span *ngIf="registerForm.get('lastName').errors?.required">
              Please enter your last name.
            </span>
            <span *ngIf="registerForm.get('lastName').errors?.maxlength">
              The last name must be less than 50 characters.
            </span>
          </span>
                </div>
            </div>

            <div class="form-group row mb-2">
                <label class="col-md-2 col-form-label"
                       for="password">Password</label>
                <div class="col-md-8">
                    <input class="form-control"
                           id="password"
                           type="password"
                           placeholder="Password (required)"
                           formControlName="password"
                           [ngClass]="{'is-invalid': (registerForm.get('password').touched ||
                                            registerForm.get('password').dirty) &&
                                            !registerForm.get('password').valid }"/>
                    <span class="invalid-feedback">
            <span *ngIf="registerForm.get('password').errors?.required">
              Please enter your password.
            </span>
            <span *ngIf="registerForm.get('password').errors?.minlength">
              The password must be longer than 3 characters.
            </span>
          </span>
                </div>
            </div>

            <div class="form-group row mb-2">
                <label class="col-md-2 col-form-label" for="roles">Role</label>
                <div class="col-md-8">
                    <select id="roles" class="form-control" formControlName="roles">
                        <option selected>subscriber</option>
                        <option>contributor</option>
                        <option>author</option>
                        <option>editor</option>
                        <option>administrator</option>
                    </select>
                </div>
            </div>

            <div class="form-group row mb-2">
                <div class="offset-md-2 col-md-4">
                    <button class="btn btn-primary mr-3"
                            type="submit"
                            style="width:80px"
                            [title]="registerForm.valid ? 'Save your entered data' : 'Disabled until the form data is valid'"
                            [disabled]="!registerForm.valid">
                        Sign up
                    </button>
                </div>
            </div>
        </form>
    </div>
</div>